@echo off
rem **************************************************************
rem *  This is an MS-DOS BATCH file for uploading
rem *  a Tools/400 utility to a given host.
rem **************************************************************
set APPLICATION=Log4rpg
set TEMPFILE=%APPLICATION%.ftpcmds
set HOST=%1
set USER=%2
set PASSWORD=%3
set LIB=QGPL
set FILE=QXML
set PATTERN=%APPLICATION%*.xml
set TMP_FTP_BAT=%APPLICATION%_executeFtp.bat
set TMP_FTP_LOG=%APPLICATION%_executeFtp.log
set TMP_FIND=%APPLICATION%_find.bat

if "%HOST%"=="" goto help
if "%USER%"=="" goto help
if "%PASSWORD%"=="" goto help

:findFile
set count=0
for %%f in (%PATTERN%) do (
   set /a count+=1
   set LCL_FILE=%%f
)
if not "%count%"=="1" (goto tooMuchFiles)



:askUser
cls
echo *************************************************************
echo   You are about to uploaded %LCL_FILE% to 
echo   file %LIB%/%FILE% and member '%APPLICATION%' on host %HOST%.
echo.
echo   If member '%APPLICATION%' in file %LIB%/%FILE% does 
echo   already exist it will be deleted.
echo *************************************************************
set choice=
set /p choice=Do you want to continue? (y/n)
if /i "%choice%"=="y" goto continue
if /i "%choice%"=="n" goto end
goto askUser

:continue
echo %USER%> %TEMPFILE%
echo %PASSWORD%>> %TEMPFILE%
echo quote CRTP FILE(%LIB%/%FILE%) RCDLEN(112) FILETYPE(*SRC) MBR(*NONE) SIZE(*NOMAX) >> %TEMPFILE%
echo quote ADDM FILE(QGPL/QXML) MBR(LOG4RPG) SRCTYPE(UPLOADING) >> %TEMPFILE%
echo quote site namefmt 0 >> %TEMPFILE%
echo quote type c 819 >> %TEMPFILE%
echo put %LCL_FILE% %LIB%/%FILE%.%APPLICATION% >> %TEMPFILE%
echo quote rcmd CHGPFM FILE(%LIB%/%FILE%) MBR(%APPLICATION%) SRCTYPE(XML) TEXT('XML Distribution of %APPLICATION%') >> %TEMPFILE%
echo quit >> %TEMPFILE%

echo ftp -s:%TEMPFILE% %HOST% > %TMP_FTP_BAT%

echo Uploading %LCL_FILE% to host %HOST% ...
call %TMP_FTP_BAT% > %TMP_FTP_LOG%

echo Checking FTP return status ...
echo find "226 " %TMP_FTP_LOG% > %TMP_FIND%
call %TMP_FIND% > nul
set FTP_STATUS=%errorlevel%

del %TEMPFILE%
del %TMP_FTP_BAT%
del %TMP_FTP_LOG%
del %TMP_FIND%

if not RC%FTP_STATUS%==RC0 goto error

echo *************************************************************
echo   Successfully uploaded member %APPLICATION% to file %FILE% 
echo   in library %LIB% on host %HOST%.
echo *************************************************************
goto end

:error
echo *************************************************************
echo   ERROR:
echo   Failed to upload member %APPLICATION% to file %FILE% 
echo   in library %LIB% on host %HOST%!
echo *************************************************************
goto end

:tooMuchFiles
echo.
echo. Error: Too much files matching pattern %PATTERN% found!
for %%f in (%PATTERN%) do (
   echo.        %%f
)
echo.
echo. Stopped uploading %APPLICATION% to host: %HOST%.
echo.
goto end

:help
echo.
echo Uploads the %APPLICATION% utility to your System i (AS/400, iSeries, i5, ...)
echo.
echo. upload_%APPLICATION%.bat HOST USER PASSWORD
echo.
echo      HOST = FTP host you want to upload to (as400.example.com)
echo      USER = UserID to log in with
echo  PASSWORD = Password to log in with
echo.
:end 