/*
 * 2006, Thomas Raddatz.
 *
 * 
 * Copyright 1999,2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.tools400.log4j.net;

import java.beans.PropertyDescriptor;
import java.beans.SimpleBeanInfo;


/**
 * BeanInfo class for the XMLSocketHubReceiver.
 *
 * @author Thomas Raddatz <thomas.raddatz@tools400.de>
 *
 */
public class XMLSocketHubReceiverBeanInfo extends SimpleBeanInfo {

    /* (non-Javadoc)
     * @see java.beans.BeanInfo#getPropertyDescriptors()
     */
    public PropertyDescriptor[] getPropertyDescriptors() {

        try {

            return new PropertyDescriptor[] {
                new PropertyDescriptor("name", XMLSocketHubReceiver.class),
                new PropertyDescriptor("host", XMLSocketHubReceiver.class),
                new PropertyDescriptor("port", XMLSocketHubReceiver.class),
                new PropertyDescriptor("threshold", XMLSocketHubReceiver.class),
                new PropertyDescriptor("reconnectionDelay", XMLSocketHubReceiver.class),
            };
        } catch (Exception e) {
        }

        return null;
    }
}
